#include <avr/io.h>	// Wir brauchen Zugriff auf die I/O's des Controllers
#include <stdlib.h>	//fr Funk. dtostrf() und itoa()
#include <string.h>	//wird fr die Funktion "strcmp" bentigt

#define delay 525 //dieser Wert ergibt in der Pauseschleife 1ms
#define F_CPU 3686400       // Quarztakt
#define UART_BAUD_RATE 9600 // Wir versuchen es mal mit 9600 Baud
#define UCR UCSRB			// UART-Control-Register  auf den verwendeten Namen des Tutorials setzen
#define USR UCSRA			// UART-Control-Register  auf den verwendeten Namen des Tutorials setzen


typedef char  BYTE;
typedef long int   WORD;
char buffer[32]; 	//maximale lnge des zu empfangenen Textes
int pos;			//momentane Position im Buffer
int sendestatus,sec;

WORD x,y;

WORD Abs(long double a)
{
  return (a >= 0) ? a : -a;
}


void pause_ms(int laenge)
{
	for(int i=0; i<laenge; i++)
	{
		for(long d=0; d<delay; d++)
		{
			long a = 2520, b = 88990, c = a * b; a = c; // sinnlose Beschftigung die viel Zeit kostet
		};
	};
	
}


void COM_init(void) //Festlegung, wie die RS232 genutz wird
{
    outp ((1<<TXEN)|(1<<RXEN),UCR); //Senden und Empfangen eingeschaltet
    outp (F_CPU / (UART_BAUD_RATE * 16L) - 1, UBRRL); // Baut-Ratenberechnung
    for (int i = 0; i < 32; i++)	//Zeichenspeicher Lschen
		buffer[i] = 0;
	pos = 0; 						// momentane Lnge
}

void COM_lauschen(void) //Kommt da was von der RS232?
{
	if (inp(USR) & (1 << RXC))	// Bit RXC im USR gesetzt ?
	{    
		char ch=inp(UDR);		//Zeichen aus dem Leseregister holen
		buffer[pos] = ch;		//Zeichen in den Buffer an momentane Position setzen
		buffer[pos+1]=0;		//nachfolgendes Zeichen ist immer eine Null (momentanes Zeichenkettenende)
		if(pos<31)				//Wenn maximale Zeichenlnge nicht erreicht ist, ...
		{
			pos++;				//... erhhe die Position im Buffer!
		}
	}
}

void COM_Auswertung(void)
{
    if(pos >= 1) //&& (buffer[pos-2]==13) && (buffer[pos-1]==10)) || (pos>=31) )
    {

        if (strcmp(buffer , "1") == 0)
        {
            //StringAusgabe("\n Jetzt geht's los!\r\n");
            sendestatus=1;
            pos=0;
        }
        else if (strcmp(buffer, "2") == 0)
        {
            //StringAusgabe("\n Jetzt ist Schluss!\r\n");
            sendestatus=2;
            pos=0;
			//sec=0;
        }
        else if (((buffer[pos-2]==13) && (buffer[pos-1]==10))|| (pos>3))
        {
            pos=0;
            sendestatus=0;
        }
    }
}


float Poti(void) 
{
    long double a,b,c;

	sbi(ADCSR,ADSC);
	while(bit_is_set(ADCSR,ADSC));
	a=inp(ADCL);
	b=inp(ADCH);
	c=(a+b*256);				//Messe den Startwert!
	for(int d=0; d<10; d++)	//Messe 10 weitere Werte!
	{
		sbi(ADCSR,ADSC);
		while(bit_is_set(ADCSR,ADSC));
		a=inp(ADCL);
		b=inp(ADCH);
		c=(c+(a+b*256));
	}
	c=(c*0.004932)/11; 		//Mittelwert aus 11 Messungen
	return(c);
}

float Temp(void) 
{
    long double d,Rx,T;
	
	d=Poti();
	Rx=(d*10000)/(5.05-d);	// Widerstandswert des Fhlers 10000 Ohm
	T=(8e-17)*Rx*Rx*Rx*Rx-(8e-12)*Rx*Rx*Rx+(3e-7)*Rx*Rx-0.0063*Rx+65.225;	//Polynom der Temperatur-
																			//Widerstandskurve
	return (T); //Rckgabe der Temperatur
}


void CharAusgabe(char str) // Ausgabe einzelner Zeichen
{
    outp (str, UDR);		// Ausgabe des Zeichens
    loop_until_bit_is_set (USR, UDRE);//warte, bis das Zeichen gesendet wurde (USR=1 zu USR=0)
}

void StringAusgabe(char *str)	// Ausgabe von Zeichenketten (*) bedeutet Adresszeiger der Zeichenkette
{
    while (*str != 0) {  		// solange das akutelle Zeichen nicht das Stringende-Zeichen ist
        outp (*str, UDR);		// Ausgabe des Zeichens an der aktuellen Adresse
        loop_until_bit_is_set (USR, UDRE); //warte, bis das Zeichen gesendet wurde (USR=1 zu USR=0)
		str++; 					// gehe mit dem Zeiger zum nchsten Adresswert
    }
}

void SecAusgabe(void)//Ausgabe der Sekunden ber die String-Ausgabe
{
	char str[33];	// maximale Zeichenzahl der Zeichnenkette

    itoa(sec++, str, 10);  	// "int to asci " um Zahlen ausgeben zu knnen
	StringAusgabe(str); // Sekunden
		
}

void FloatAusgabe(double x) 	//Ausgabe einer Kommazahl ber die String-Ausgabe
{
  char buffer[50];
  StringAusgabe(dtostrf(x, 5, 4, buffer));  // 5 Vorkommastellen, 4 Nachkommastellen
}

void Baseline(void)
{
	long double messwertneu, messwertalt,diff;
	messwertneu=Temp();
	messwertalt = messwertneu;
	diff=10;
	
	while (Abs(diff)>3)// die Zahl gibt an, wieviel hundertstel genau die 
						// Temperatur "still" stehen soll
	{
		messwertalt = messwertneu;
		for(int d=0; d<10 ; d++)
		{
			//COM_lauschen(); //Hrt der COM-Port was?
			//COM_Auswertung();   //Was hat er denn gehrt? Sendestatus wird definiert!
			if(sendestatus==1)
			{
				SecAusgabe();
				StringAusgabe("	");		//nchste Spalte
				FloatAusgabe(Temp());			//Ausgabe der Temperaturen ber den Hyperterminal
				StringAusgabe("		");		//nchste Spalte
				FloatAusgabe(20);			//Offset des Temperaturanstieges
				//FloatAusgabe(Abs(diff)+10);		//Ausgabe der Temperaturschwankung der letzten 10 Messungen
				//								//mit Offset +10
				StringAusgabe("\r\n");			//Zeilenumbruch
			}
			pause_ms(1000);
		}
		messwertneu = Temp();
		diff=(messwertneu-messwertalt)*100.0;
	} 	
	
}

int Bewertung(void)
{
long double anstieg,start;

	anstieg=0;
	start=Temp();
	for(int d=0; d<40 ; d++)
	{
		//COM_lauschen(); //Hrt der COM-Port was?
		//COM_Auswertung();   //Was hat er denn gehrt?
		if(sendestatus==1)
		{
			SecAusgabe();
				StringAusgabe("	");		//nchste Spalte
				FloatAusgabe(Temp());			//Ausgabe der Temperaturen ber den Hyperterminal
				StringAusgabe("		");		//nchste Spalte
				FloatAusgabe(Temp()-start+20);	//Ausgabe des Temperaturanstieges mit einem Offset von 20
				StringAusgabe("\r\n");			//Zeilenumbruch
		}
		pause_ms(1000);
	}
	anstieg=(Temp()-start);
	return(Abs(anstieg));
}


void Heizung(int a)
{
	if(a==1)  sbi(PORTD,2); //HZ.2 an
	if(a==2)  sbi(PORTD,3); //HZ.1 an
	if(a==3)  sbi(PORTB,2); //Vw. an
	if(a==0) 
	{
		cbi(PORTD,2);
		cbi(PORTD,3);
		cbi(PORTB,2);
	}	
}

int main (void)
{
	//outp (0x00,DDRC);
	//outp (0xff,PORTC);
	outp (0xff,DDRD);	// Port D als ausgang 
	outp (0x00,PORTD);	// PORT D 0..7 auf 0 
	outp (0xfd,DDRB);	// Port B als ausgang ausser PB1
	outp (0x02,PORTB);	// PORT B 0..7 auf 0 bzw. pull-up
	outp (0x84,ADCSR); 	// ADC aktivieren und Frequenzteiler auf 32 (ca.4Mhz/32 = ca.125kHz )
	sendestatus=0;
	sec=0;
	
	 COM_init();
	
	
	
	//--------------Lampentest-----------------------------------------------------------------
	sbi(PORTB,3); //Messung luft
	sbi(PORTB,4); //Hz1 ok
	pause_ms(600);
	cbi(PORTB,4); //Hz1 ok
	sbi(PORTD,4); //Hz2 ok
	pause_ms(600);
	cbi(PORTD,4);	//Hz2 ok
	sbi(PORTD,6); //Hz3 ok
	pause_ms(600);
	cbi(PORTD,6); //Hz3 ok
	sbi(PORTB,5); //Hz1 def
	pause_ms(600);
	cbi(PORTB,5); //Hz1 def
	sbi(PORTD,5); //Hz2 def
	pause_ms(600);
	cbi(PORTD,5); //Hz2 def
	sbi(PORTD,7); //Hz3 def
	pause_ms(600);
	cbi(PORTD,7); //Hz3 def
	cbi(PORTB,3);
	//--------------------------------------------------------------------------------
	
	for(;;)
	{
	
	while(bit_is_set(PINB,1));
	sendestatus=1;
	sec=0;
	StringAusgabe("""Sek.	Temp.		Diff+20\r\n");
	sbi(PORTB,3); //Messung luft
	cbi(PORTB,4);
	cbi(PORTB,5);
	cbi(PORTD,4);
	cbi(PORTD,5);
	cbi(PORTD,6);
	cbi(PORTD,7);
	Heizung(0);
	outp (0x02,ADMUX);	// ADC 10bit Kanal 02 (PC2)   SB1 Fhlertest
	Baseline();
	Heizung(2);
	(Bewertung()*10<15) ? sbi(PORTB,5):sbi(PORTB,4);
	Heizung(0);
	outp (0x00,ADMUX);	// ADC 10bit Kanal 00 (PC0)   SB2 Fhlertest
	Baseline();
	Heizung(1);
	(Bewertung()*10<15) ? sbi(PORTD,5):sbi(PORTD,4);
	Heizung(0);
	outp (0x01,ADMUX);	// ADC 10bit Kanal 01 (PC1)   SB-Vw Fhlertest
	Baseline();
	Heizung(3);
	(Bewertung()*10<15) ? sbi(PORTD,7):sbi(PORTD,6);
	Heizung(0);
	sendestatus=0;
	cbi(PORTB,3); //Messung Ende
	
	
	
	}

}

